from emod_api import schema_to_class as s2c
import json

def MEVacc( coverage=1.0, qual_ac=0, qual_trn=1.0, group_names="", timestep=1, nods=[] ):
    event = s2c.get_class_with_defaults( "CampaignEvent", schema_path )
    coordinator = s2c.get_class_with_defaults( "StandardEventCoordinator", schema_path )
    if coordinator is None:
        print( "s2c.get_class_with_defaults returned None. Maybe no schema.json was provided." )
        return "" 
    event.Event_Coordinator_Config = coordinator
    intervention = s2c.get_class_with_defaults( "MultiEffectVaccine", schema_path )
    coordinator.Intervention_Config = intervention
    event.Start_Day = float(timestep)

    coordinator.Property_Restrictions_Within_Node: group_names

    intervention.Cost_To_Consumer = 0
    intervention.Intervention_Name = "me_vacc"
    intervention.Vaccine_Take = coverage
    #intervention.Vaccine_Type = "TransmissionBlocking" # MEV doesn't have a type. It's all types.
                     
    a_waning = s2c.get_class_with_defaults( "WaningEffectConstant", schema_path )
    a_waning.Initial_Effect = qual_ac
    t_waning = s2c.get_class_with_defaults( "WaningEffectConstant", schema_path )
    t_waning.Initial_Effect = qual_trn
    m_waning = s2c.get_class_with_defaults( "WaningEffectConstant", schema_path )
    m_waning.Initial_Effect = 1.0
    
    intervention.Acquire_Config = a_waning
    intervention.Transmit_Config = t_waning
    intervention.Mortality_Config = m_waning

    if len(nods) > 0:
        nodelist = s2c.get_class_with_defaults( "NodeSetNodeList", schema_path )
        nodelist.Node_List = nods
        event.Nodeset_Config = nodelist
        nodelist.finalize()

    coordinator.finalize()
    intervention.finalize()
    a_waning.finalize()
    t_waning.finalize()
    m_waning.finalize()
    event.finalize()
    event["Event_Name"] = "Quarantine..."
    return event
