#!/usr/bin/python
import json
import numpy as np
import random

"""
S=Senior (actually not yet)
W=Working Age Adult
C=Adult in Community (e.g.,SAHM) or baby
HS=High School
JH=Junior High
ES=Elem School

Nothing for daycare or college in this toy example

Create a bunch of households with increasing idsfrom 000 up to 10k total people.

size of hh is exponential, at least 1, mean = 3. (why not?)

Always start with adult.

If need another person:
    50% prob adult, 50% prob not
    pick between 
"""

def build_households( pop ):
    second_random = { 0: "W", 1: "C", 2: "HS", 3: "JH", 4: "ES" }
    child_random = { 0: "C", 1: "HS", 2: "JH", 3: "ES"  }

    hhs = {}
    person_id = 0
    hh_id = 1
    while person_id < pop:
        hhs[hh_id] = [] # insert elem into dict for all members of this household
        hh_size = int(np.random.exponential(2)+1)
        for member in range(hh_size):
            if member == 0:
                # pick an adult
                hhs[hh_id].append( "W" )
            elif member == 1:
                hhs[hh_id].append( second_random[ random.randint( 0,4 ) ] )
            else:
                hhs[hh_id].append( child_random[ random.randint( 0,3 ) ] )
                # 33% W, C, or student
            person_id += 1
        hh_id += 1
    return hhs

def write_households( pop_size ):
    household_dict = build_households( pop_size )
    filename = "households_{}.json".format( pop_size )
    with open( filename, "w+" ) as hh_file:
        json.dump( household_dict , hh_file, sort_keys=True, indent=4 )
    return filename

if __name__ == "__main__":
    import argparse
    parser = argparse.ArgumentParser()
    parser.add_argument('-p', '--populationsize', type=int, default=200, help="Number of people in population")
    args = parser.parse_args()

    write_households(args.populationsize) 
